Index: /branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingFeatureCorrelationView.cs
===================================================================
--- /branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingFeatureCorrelationView.cs	(revision 14469)
+++ /branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingFeatureCorrelationView.cs	(revision 14470)
@@ -27,5 +27,5 @@
 namespace HeuristicLab.Problems.DataAnalysis.Views {
   [View("Preprocessing Feature Correlation View")]
-  [Content(typeof(CorrelationMatrixContent), false)]
+  [Content(typeof(CorrelationMatrixContent), true)]
   public partial class PreprocessingFeatureCorrelationView : AsynchronousContentView {
 
Index: /branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/ScatterPlotSingleView.Designer.cs
===================================================================
--- /branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/ScatterPlotSingleView.Designer.cs	(revision 14469)
+++ /branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/ScatterPlotSingleView.Designer.cs	(revision 14470)
@@ -118,5 +118,5 @@
       this.comboBoxGroup.Size = new System.Drawing.Size(121, 21);
       this.comboBoxGroup.TabIndex = 1;
-      this.comboBoxGroup.SelectedIndexChanged += new System.EventHandler(this.comboBox_SelectedIndexChanged);
+      this.comboBoxGroup.SelectedIndexChanged += new System.EventHandler(this.comboBoxGroup_SelectedIndexChanged);
       // 
       // comboBoxYVariable
@@ -129,5 +129,5 @@
       this.comboBoxYVariable.Size = new System.Drawing.Size(121, 21);
       this.comboBoxYVariable.TabIndex = 1;
-      this.comboBoxYVariable.SelectedIndexChanged += new System.EventHandler(this.comboBox_SelectedIndexChanged);
+      this.comboBoxYVariable.SelectedIndexChanged += new System.EventHandler(this.comboBoxYVariable_SelectedIndexChanged);
       // 
       // comboBoxXVariable
@@ -140,5 +140,5 @@
       this.comboBoxXVariable.Size = new System.Drawing.Size(121, 21);
       this.comboBoxXVariable.TabIndex = 0;
-      this.comboBoxXVariable.SelectedIndexChanged += new System.EventHandler(this.comboBox_SelectedIndexChanged);
+      this.comboBoxXVariable.SelectedIndexChanged += new System.EventHandler(this.comboBoxXVariable_SelectedIndexChanged);
       // 
       // ScatterPlotSingleView
Index: /branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/ScatterPlotSingleView.cs
===================================================================
--- /branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/ScatterPlotSingleView.cs	(revision 14469)
+++ /branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/ScatterPlotSingleView.cs	(revision 14470)
@@ -82,8 +82,4 @@
     }
 
-    private void comboBox_SelectedIndexChanged(object sender, EventArgs e) {
-      UpdateScatterPlot();
-    }
-
     private void UpdateScatterPlot() {
       if (comboBoxXVariable.SelectedItem != null && comboBoxYVariable.SelectedItem != null && comboBoxGroup.SelectedItem != null) {
@@ -105,4 +101,45 @@
       }
     }
+
+    private void comboBoxXVariable_SelectedIndexChanged(object sender, EventArgs e) {
+      var oldPlot = scatterPlotControl.Content;
+      UpdateScatterPlot();
+      var newPlot = scatterPlotControl.Content;
+
+
+      if (oldPlot == null || newPlot == null) return;
+      newPlot.VisualProperties.YAxisMinimumAuto = oldPlot.VisualProperties.YAxisMinimumAuto;
+      newPlot.VisualProperties.YAxisMaximumAuto = oldPlot.VisualProperties.YAxisMaximumAuto;
+      newPlot.VisualProperties.YAxisMinimumFixedValue = oldPlot.VisualProperties.YAxisMinimumFixedValue;
+      newPlot.VisualProperties.YAxisMaximumFixedValue = oldPlot.VisualProperties.YAxisMaximumFixedValue;
+
+      foreach (var x in newPlot.Rows.Zip(oldPlot.Rows, (nr, or) => new { nr, or })) {
+        x.nr.VisualProperties.PointSize = x.or.VisualProperties.PointSize;
+        x.nr.VisualProperties.PointStyle = x.or.VisualProperties.PointStyle;
+        x.nr.VisualProperties.Color = x.or.VisualProperties.Color;
+      }
+    }
+
+    private void comboBoxYVariable_SelectedIndexChanged(object sender, EventArgs e) {
+      var oldPlot = scatterPlotControl.Content;
+      UpdateScatterPlot();
+      var newPlot = scatterPlotControl.Content;
+
+      if (oldPlot == null || newPlot == null) return;
+      newPlot.VisualProperties.XAxisMinimumAuto = oldPlot.VisualProperties.XAxisMinimumAuto;
+      newPlot.VisualProperties.XAxisMaximumAuto = oldPlot.VisualProperties.XAxisMaximumAuto;
+      newPlot.VisualProperties.XAxisMinimumFixedValue = oldPlot.VisualProperties.XAxisMinimumFixedValue;
+      newPlot.VisualProperties.XAxisMaximumFixedValue = oldPlot.VisualProperties.XAxisMaximumFixedValue;
+
+      foreach (var x in newPlot.Rows.Zip(oldPlot.Rows, (nr, or) => new { nr, or })) {
+        x.nr.VisualProperties.PointSize = x.or.VisualProperties.PointSize;
+        x.nr.VisualProperties.PointStyle = x.or.VisualProperties.PointStyle;
+        x.nr.VisualProperties.Color = x.or.VisualProperties.Color;
+      }
+    }
+
+    private void comboBoxGroup_SelectedIndexChanged(object sender, EventArgs e) {
+      UpdateScatterPlot();
+    }
   }
 }
Index: /branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/ViewShortcutListView.cs
===================================================================
--- /branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/ViewShortcutListView.cs	(revision 14469)
+++ /branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/ViewShortcutListView.cs	(revision 14470)
@@ -46,10 +46,13 @@
         IViewShortcut item = itemsListView.SelectedItems[0].Tag as IViewShortcut;
         if (item != null) {
-          item = (IViewShortcut)item.Clone();
-
-          var view = MainFormManager.MainForm.ShowContent(item);
-          if (view != null) {
-            view.ReadOnly = ReadOnly;
-            view.Locked = Locked;
+          try {
+            item = (IViewShortcut)item.Clone();
+            var view = MainFormManager.MainForm.ShowContent(item);
+            if (view != null) {
+              view.ReadOnly = ReadOnly;
+              view.Locked = Locked;
+            }
+          } catch (NullReferenceException) {
+            // cloning for preprocessing not done properly yet
           }
         }