Index: branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/ScatterPlotMultiView.cs
===================================================================
--- branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/ScatterPlotMultiView.cs	(revision 14492)
+++ branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/ScatterPlotMultiView.cs	(revision 14495)
@@ -267,4 +267,6 @@
         } else { //scatter plot
           var scatterPlot = Content.CreateScatterPlot(colVariable, rowVariable);
+          foreach (var row in scatterPlot.Rows)
+            row.VisualProperties.PointSize = 3;
           scatterPlot.VisualProperties.Title = string.Empty;
           var scatterPlotControl = new /*Preprocessing*/ScatterPlotControl {
Index: branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/ScatterPlotSingleView.cs
===================================================================
--- branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/ScatterPlotSingleView.cs	(revision 14492)
+++ branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing.Views/3.4/ScatterPlotSingleView.cs	(revision 14495)
@@ -88,4 +88,6 @@
         var groupVariable = (string)comboBoxGroup.SelectedItem;
         ScatterPlot scatterPlot = Content.CreateScatterPlot(xVariable, yVariable, groupVariable);
+        foreach (var row in scatterPlot.Rows)
+          row.VisualProperties.PointSize = 6;
         var vp = scatterPlot.VisualProperties;
         vp.Title = string.Empty;
@@ -115,7 +117,7 @@
 
       foreach (var x in newPlot.Rows.Zip(oldPlot.Rows, (nr, or) => new { nr, or })) {
-        x.nr.VisualProperties.PointSize = x.or.VisualProperties.PointSize;
-        x.nr.VisualProperties.PointStyle = x.or.VisualProperties.PointStyle;
-        x.nr.VisualProperties.Color = x.or.VisualProperties.Color;
+        var newVisuapProperties = (ScatterPlotDataRowVisualProperties)x.or.VisualProperties.Clone();
+        newVisuapProperties.DisplayName = x.nr.VisualProperties.DisplayName;
+        x.nr.VisualProperties = newVisuapProperties;
       }
     }
@@ -133,7 +135,7 @@
 
       foreach (var x in newPlot.Rows.Zip(oldPlot.Rows, (nr, or) => new { nr, or })) {
-        x.nr.VisualProperties.PointSize = x.or.VisualProperties.PointSize;
-        x.nr.VisualProperties.PointStyle = x.or.VisualProperties.PointStyle;
-        x.nr.VisualProperties.Color = x.or.VisualProperties.Color;
+        var newVisuapProperties = (ScatterPlotDataRowVisualProperties)x.or.VisualProperties.Clone();
+        newVisuapProperties.DisplayName = x.nr.VisualProperties.DisplayName;
+        x.nr.VisualProperties = newVisuapProperties;
       }
     }
Index: branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing/3.4/Content/ScatterPlotContent.cs
===================================================================
--- branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing/3.4/Content/ScatterPlotContent.cs	(revision 14492)
+++ branches/DataPreprocessing Enhancements/HeuristicLab.DataPreprocessing/3.4/Content/ScatterPlotContent.cs	(revision 14495)
@@ -42,22 +42,27 @@
       ScatterPlot scatterPlot = new ScatterPlot();
 
-      IList<double> xValues = PreprocessingData.GetValues<double>(PreprocessingData.GetColumnIndex(variableNameX));
-      IList<double> yValues = PreprocessingData.GetValues<double>(PreprocessingData.GetColumnIndex(variableNameY));
+      IList<double> xValues = PreprocessingData.GetValues<double>(PreprocessingData.GetColumnIndex(variableNameX)).Where(x => !double.IsNaN(x) && !double.IsInfinity(x)).ToList();
+      IList<double> yValues = PreprocessingData.GetValues<double>(PreprocessingData.GetColumnIndex(variableNameY)).Where(x => !double.IsNaN(x) && !double.IsInfinity(x)).ToList();
 
-      double axisMin, axisMax, axisInterval;
-      try {
-        ChartUtil.CalculateOptimalAxisInterval(xValues.Min(), xValues.Max(), out axisMin, out axisMax, out axisInterval);
-        scatterPlot.VisualProperties.XAxisMinimumAuto = false;
-        scatterPlot.VisualProperties.XAxisMaximumAuto = false;
-        scatterPlot.VisualProperties.XAxisMinimumFixedValue = axisMin;
-        scatterPlot.VisualProperties.XAxisMaximumFixedValue = axisMax;
-      } catch (ArgumentOutOfRangeException) { } // missing values lead to NaNs
-      try {
-        ChartUtil.CalculateOptimalAxisInterval(yValues.Min(), yValues.Max(), out axisMin, out axisMax, out axisInterval);
-        scatterPlot.VisualProperties.YAxisMinimumAuto = false;
-        scatterPlot.VisualProperties.YAxisMaximumAuto = false;
-        scatterPlot.VisualProperties.YAxisMinimumFixedValue = axisMin;
-        scatterPlot.VisualProperties.YAxisMaximumFixedValue = axisMax;
-      } catch (ArgumentOutOfRangeException) { } // missing values lead to NaNs
+      if (xValues.Any()) {
+        try {
+          double axisMin, axisMax, axisInterval;
+          ChartUtil.CalculateOptimalAxisInterval(xValues.Min(), xValues.Max(), out axisMin, out axisMax, out axisInterval);
+          scatterPlot.VisualProperties.XAxisMinimumAuto = false;
+          scatterPlot.VisualProperties.XAxisMaximumAuto = false;
+          scatterPlot.VisualProperties.XAxisMinimumFixedValue = axisMin;
+          scatterPlot.VisualProperties.XAxisMaximumFixedValue = axisMax;
+        } catch (ArgumentOutOfRangeException) { } // error during CalculateOptimalAxisInterval 
+      }
+      if (yValues.Any()) {
+        try {
+          double axisMin, axisMax, axisInterval;
+          ChartUtil.CalculateOptimalAxisInterval(yValues.Min(), yValues.Max(), out axisMin, out axisMax, out axisInterval);
+          scatterPlot.VisualProperties.YAxisMinimumAuto = false;
+          scatterPlot.VisualProperties.YAxisMaximumAuto = false;
+          scatterPlot.VisualProperties.YAxisMinimumFixedValue = axisMin;
+          scatterPlot.VisualProperties.YAxisMaximumFixedValue = axisMax;
+        } catch (ArgumentOutOfRangeException) { } // error during CalculateOptimalAxisInterval 
+      }
 
       if (variableNameGroup == null || variableNameGroup == "-") {
@@ -69,7 +74,5 @@
         }
 
-        ScatterPlotDataRow scdr = new ScatterPlotDataRow(variableNameX + " - " + variableNameY, "", points) {
-          VisualProperties = { PointSize = 6 }
-        };
+        ScatterPlotDataRow scdr = new ScatterPlotDataRow(variableNameX + " - " + variableNameY, "", points);
         scdr.VisualProperties.IsVisibleInLegend = false;
         scatterPlot.Rows.Add(scdr);